
def sqrt(x, epsilon):
    approx = x / 2
    while abs(x - approx) > epsilon:
        approx = 0.5 * (approx + x / approx)
    return approx

"""
Square Root

Newton-Raphson method implementation.


Input:
    x: A float
    epsilon: A float

Precondition:
    x >= 1 and epsilon > 0

Output:
    A float in the interval [sqrt(x) - epsilon, sqrt(x) + epsilon]

Example:
    >>> sqrt(2, 0.01)
    1.4166666666666665
"""
